import { atom, selector } from 'recoil';
export function bootstrappedAtom(bootstrapRootAtom, { initialValue, key, ...options }) {
    if ('default' in options) {
        throw new Error('The "default" prop is not allowed in bootstrapped atoms. Use "initialValue" instead');
    }
    return atom({
        ...options,
        key,
        // We set the default to a selector so that we can grab the bootstrap data
        // from the bootstrapRootAtom, which is set in a BootstrapRoot component
        default: selector({
            key: `${key}:atomInitializer`,
            get: ({ get }) => initialValue(get(bootstrapRootAtom)),
        }),
    });
}
//# sourceMappingURL=bootstrappedAtom.js.map